*** ../wavelan.orig/wicontrol.c	Thu Jan 17 11:24:20 2002
--- wicontrol.c	Thu Jan 17 13:20:38 2002
***************
*** 620,629 ****
--- 620,717 ----
  	fprintf(stderr, "\t%s -i iface -Z zero out signal cache\n", p);
  	fprintf(stderr, "\t%s -i iface -C print signal cache\n", p);
  #endif
+ 	fprintf(stderr, "\t%s -i iface -A scan access points\n", p);
  
  	exit(1);
  }
  
+ static void wi_apscan(iface)
+ 	char			*iface;
+ {
+ 	int s;
+ 	struct wi_req		wreq;
+ 	struct ifreq		ifr;
+ 	int naps;
+ 	int retries = 10;	/* number of seconds to retry */
+ 	struct wi_apinfo *w;
+ 	int i, j;
+ 
+ 	if (iface == NULL)
+ 		errx(1, "must specify interface name");
+ 
+ 	bzero((char *)&wreq, sizeof(wreq));
+ 
+ 	wreq.wi_type = WI_RID_SCAN_APS;
+ 	wreq.wi_len = 4;
+ 	/* note chan. 1 is the least significant bit */
+ 	wreq.wi_val[0] = 0x7ff;  /* 1 bit per channel, 1-11 */
+ 	wreq.wi_val[1] = 3;      /* tx rate */
+ 
+ 	/* write the request
+ 	*/
+ 	wi_setval(iface, &wreq);
+ 
+ 	/* now poll for a result
+ 	*/
+ 	bzero((char *)&wreq, sizeof(wreq));
+ 	wreq.wi_len = WI_MAX_DATALEN;
+ 	wreq.wi_type = WI_RID_READ_APS;
+ 
+ 	/* we have to do this ourself as opposed to
+ 	 * using setval, because we cannot bail if
+ 	 * the ioctl fails
+ 	 */
+ 	strlcpy(ifr.ifr_name, iface, sizeof(ifr.ifr_name));
+ 	ifr.ifr_data = (caddr_t)&wreq;
+ 
+ 	s = socket(AF_INET, SOCK_DGRAM, 0);
+ 
+ 	if (s == -1)
+ 		err(1, "socket");
+ 
+ 	setbuf(stdout, NULL);
+ 	printf("scanning ...");
+ 	while (ioctl(s, SIOCGWAVELAN, &ifr) == -1) {
+ 		retries--;
+ 
+ 		if (retries >= 0) {
+ 			printf(".");
+ 			sleep(1);
+ 		}
+ 		else {
+ 			break;
+ 		}
+ 		errno = 0;
+ 	}
+ 
+ 	close(s);
+ 	if (errno) {
+ 		perror("ioctl");
+ 		exit(1);
+ 	}
+ 	printf("\n");
+ 
+ 	naps = (int) wreq.wi_val[0]; 
+ 	w =  (struct wi_apinfo *) (((char *)&wreq.wi_val) + sizeof(int));
+ 	for ( i = 0; i < naps; i++, w++) {
+ 		printf("ap[%d]:\n", i);
+ 		printf("\tnetname: ");
+                 for (j = 0; j < w->namelen; j++) {
+                         printf("%c", w->name[j]);
+                 }
+                 printf("\n");
+ 		printf("\tchannel: %d\n", w->channel);
+ 		printf("\tquality/signal/noise: %d %d %d \n", 
+ 			w->quality, w->signal, w->noise);
+                 printf("\tBSSID - %x:%x:%x:%x:%x:%x\n",
+                         w->bssid[0]&0xff, w->bssid[1]&0xff,
+                         w->bssid[2]&0xff, w->bssid[3]&0xff,
+                         w->bssid[4]&0xff, w->bssid[5]&0xff);
+                 printf("\tbeacon interval: %d\n", w->interval); 
+                 printf("\tcapinfo: %x\n", w->capinfo); 
+ 	}
+ }
+ 
  #ifdef WICACHE
  static void wi_zerocache(iface)
  	char			*iface;
***************
*** 710,717 ****
  	opterr = 1;
  		
  	while((ch = getopt(argc, argv,
! 	    "a:hoc:d:e:f:i:k:p:r:q:t:n:s:m:v:P:S:T:ZC")) != -1) {
  		switch(ch) {
  		case 'Z':
  #ifdef WICACHE
  			wi_zerocache(iface);
--- 798,808 ----
  	opterr = 1;
  		
  	while((ch = getopt(argc, argv,
! 	    "a:hoc:d:e:f:i:k:p:r:q:t:n:s:m:v:P:S:T:ZCA")) != -1) {
  		switch(ch) {
+ 		case 'A':
+ 			wi_apscan(iface);
+ 			exit(0);	
  		case 'Z':
  #ifdef WICACHE
  			wi_zerocache(iface);
